///////////////////////////////////////////////////////////////////////////////
//
// CutCharge
// --------------
//
// Authors: Reinhard Schwienhorst
//         
//
// Date: April 8, 2005
//
// Modified:
// 
//
///////////////////////////////////////////////////////////////////////////////

#include "single_top_analysis/CutCharge.hpp"
#include <iostream>

using namespace std;


//----------------
// constructor
//----------------
CutCharge::CutCharge(EventContainer *obj, int cs, int lf)
  : _chargeSign(cs),_leptonFlavor(lf)
{
  SetParticleObj(obj);
}

//----------------
// destructor
//----------------
CutCharge::~CutCharge()
{
  
}

//----------------
// Book
//----------------
void CutCharge::BookHistogram()
{
  _hChargeSign = DeclareTH1F("ChargeSign","Sign of top quark charge",3,-1,1);
  _hLeptonFlavor = DeclareTH1F("LeptonFlavor","Flavor code (kf) of lepton",50,-25,25);

}

//-------------
// Apply
//-------------
bool CutCharge::Apply()
{
  //cout<<"begin of cut_basic"<<endl;
  EventContainer *obj=GetParticleObj();
  
  bool passEvt=true; //obj->finalStatePass;
  if(passEvt==false) return false;

  // cut on sign of lepton
  int chargesign = static_cast<int> (obj->electrons[0].charge());
  _hChargeSign->Fill(chargesign);
  bool passChargeSign = chargesign==_chargeSign;

//   // if desired, also cut on lepton flavor
   bool passLeptonFlavor=true;
//   _hLeptonFlavor->Fill(obj->tll.kf());
//   if(_leptonFlavor!=-1) {
//     if(obj->tll.kf()!=_leptonFlavor) passLeptonFlavor=false;
//   }


  
  //cout<<"end of cut_Basic"<<endl;

  return passChargeSign && passLeptonFlavor;  
  
}












